import { createQueryStore as createQueryStore$1 } from "@sanity/core-loader";
const createQueryStore = (options) => {
  if (!options.ssr)
    throw new Error("When using React Server Components the `ssr` option must be set to `true`.");
  const { setServerClient: setServerClient2, unstable__serverClient } = createQueryStore$1({
    tag: "react-loader.rsc",
    ...options
  });
  return {
    loadQuery: async (query, params = {}, _options = {}) => {
      const { cache, next, stega, headers, tag } = _options, perspective = _options.perspective || unstable__serverClient.instance?.config().perspective || "published", useCdn = _options.useCdn || unstable__serverClient.instance.config().useCdn;
      if (perspective === "previewDrafts" && !unstable__serverClient.canPreviewDrafts)
        throw new Error(
          `You cannot use "previewDrafts" unless you set a "token" in the "client" instance you're pasing to "setServerClient".`
        );
      const { result, resultSourceMap } = await unstable__serverClient.instance.fetch(query, params, {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        cache: cache ?? next ? void 0 : "no-store",
        filterResponse: !1,
        next,
        perspective,
        useCdn: perspective === "previewDrafts" ? !1 : useCdn,
        stega,
        headers,
        tag
      }), payload = resultSourceMap ? { data: result, sourceMap: resultSourceMap } : { data: result };
      return perspective === "previewDrafts" ? { ...payload, perspective } : payload;
    },
    setServerClient: setServerClient2,
    useQuery: () => {
      throw new Error("The `useQuery` hook can only be called from a client component.");
    },
    useLiveMode: () => {
      throw new Error("The `useLiveMode` hook can only be called from a client component.");
    }
  };
}, { loadQuery, setServerClient, useLiveMode, useQuery } = createQueryStore({
  client: !1,
  ssr: !0
}), useEncodeDataAttribute = () => {
  throw new Error("The `useEncodeDataAttribute` hook can only be called from a client component.");
};
export {
  createQueryStore,
  loadQuery,
  setServerClient,
  useEncodeDataAttribute,
  useLiveMode,
  useQuery
};
//# sourceMappingURL=index.react-server.js.map
